rem = 0; /*
@echo off
chcp 65001
node %~n0%~x0 || goto :error
goto :end
rem */

/**********************
 *
 * MRPG_RT.bat v1.0.0
 *
 **********************/

const http = require("http");
const fs = require("fs");
const path = require("path");
const child_process = require("child_process");

// ==========================================

const PORT = 3000; // <- ポート番号指定

// ==========================================

const DEBUG = false;
const URL = "http://localhost:" + PORT + "/";
const START_COMMAND =
  process.platform == "darwin"
    ? "open"
    : process.platform == "win32"
    ? "start"
    : "xdg-open";

const comment = (comments) => {
  console.log(
    "\n========================================================================="
  );
  comments.forEach((c) => console.log(c));
  console.log(
    "=========================================================================\n"
  );
};

const server = http.createServer(function (request, response) {
  DEBUG && console.log("リクエスト: ", request.url);
  let filePath = "." + request.url;
  if (filePath == "./") {
    filePath = "./index.html";
  }
  const extname = String(path.extname(filePath)).toLowerCase();
  const mimeTypes = {
    ".html": "text/html",
    ".js": "text/javascript",
    ".css": "text/css",
    ".json": "application/json",
    ".png": "image/png",
    ".jpg": "image/jpg",
    ".gif": "image/gif",
    ".svg": "image/svg+xml",
    ".wav": "audio/wav",
    ".mp4": "video/mp4",
    ".woff": "application/font-woff",
    ".ttf": "application/font-ttf",
    ".eot": "application/vnd.ms-fontobject",
    ".otf": "application/font-otf",
    ".wasm": "application/wasm",
  };
  const contentType = mimeTypes[extname] || "application/octet-stream";
  fs.readFile(filePath, function (error, content) {
    if (error) {
      if (error.code == "ENOENT") {
        response.writeHead(404, { "Content-Type": "text/html" });
        response.end("404 error!");
      } else {
        response.writeHead(500);
        response.end("500 error: " + error.code, "utf-8");
      }
    } else {
      response.writeHead(200, { "Content-Type": contentType });
      response.end(content, "utf-8");
    }
  });
});
server.on("error", (error) => {
  comment([
    "エラーが発生したため、ゲームを起動できませんでした。",
    "すでに MRPG_RT.bat を起動中の場合は、終了してからお試しください。",
    "解決しない場合は、このバッチファイルをテキストエディタで開き、",
    "「ポート番号指定」の行にある " + PORT + " という半角数字を",
    "たとえば " +
      (PORT + 1) +
      " とか、" +
      (PORT + 2) +
      " とかに変更してみてください。",
  ]);
  console.log(error);
});
server.listen(PORT, () => {
  console.log("ゲームをローカルサーバー経由で起動 " + URL);
  setTimeout(() => {
    child_process.exec(START_COMMAND + " " + URL);
    console.log("リンクを呼び出しました。");
    comment([
      "ゲームを終了するときは、ゲームを閉じてからこのウィンドウを閉じてください。",
      "ゲームを閉じる前にこのウィンドウを閉じてしまうと、",
      "ゲームがファイルを読み込めなくなるため、バグります。",
    ]);
    comment([
      "セーブデータはブラウザに残ります。",
      "ブラウザの閲覧履歴の削除などをしてしまうと、データが消える可能性があります。",
    ]);
    comment([
      "タイトル画面など、最初に出てくる画面では、",
      "画面をクリックしないと音が鳴らないことがありますが、",
      "これはブラウザの仕様です。",
    ]);
  }, 1000);
});

/*
:error
echo. & echo.
echo =========================================================================
echo " MRPG_RT.bat を使用するためには Node.js のインストールが必要です。"
echo " こちらでダウンロード・インストールしてください: https://nodejs.org/ja/ "
echo =========================================================================
:end
echo. & echo.
pause
rem */
